/*****************************************************************************/
/* UDAT.C von H.J.Schilling, DJ1XK                                           */
/* Anzeigen von einzelnen Usern aus USERS4.BCM                                */
/*    ==> Struktur in mail.h <==                                             */
/*****************************************************************************/
#define MAX 10000

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <fcntl.h>

FILE *fc, *fi, *pt;
int  fd;

static unsigned char akt[650];
static char datnam[] = "users4.bcm";
static char defnam[] = "users.def";
static char ST[200][101];
static unsigned long snr;
static unsigned int zeile = 0;
static int ll;
static int typ;
static int delta;
static int arg;
static char CALL[7];
static char NAME[15];
static char MYBBS[25];
static char SPRACHE[4];
static unsigned short FILEPOS;
static char MYBBST[25];
static int PW=0;
static int f;
static int l;
/*****************************************************************************/
/* Unterprogramm zum Einlesen der DEF-Daten                                  */
/*****************************************************************************/
void def()
{
   char buf[100];
   int i;

   if((fc = fopen (defnam, "r")) == NULL)
   {
      printf("\n Konfigurations-Datei USERS.DEF nicht gefunden - Abbruch !\n");
      exit(1);
   }

   while (fgets(buf, 100, fc) != NULL)
   { 
      if(buf[0] == 35)
         continue;
      if(strncmp(buf, "PW=", 3) == 0)
      {
         PW = atoi(buf+3);
         continue;
      }
      for(i=0; buf[i] != '#'; i++)
         ST[zeile][i] = buf[i];
      ST[zeile][i] = '\0';
      zeile++;
   }
   fclose(fc);
}
/*****************************************************************************/
/* Passwort-Behandlung                                                       */
/*****************************************************************************/
password()
{
   int c, i, j;

   printf("%s", ST[zeile]+6);
   switch (PW)
   {
      case 0   : printf("%s", akt+delta);
                 break;   
      case 1   : printf("%s", strrev(akt+delta));
      case 123 : for(i=0; i<strlen(akt+delta); i+=3)
                 {
                    for(j=0; j<3; j++)       
                    {
                       c = akt[delta+i+j];
                       if(c == 0)
                          break;
                       printf("%c", c+j+1);
                    }
                 }
                 break;
      case 302 : for(i=0; i<strlen(akt+delta); i+=3)
                 {
                    for(j=0; j<3; j++)       
                    {
                       c = akt[delta+i+j];
                       if(c == 0)
                          break;
                       switch (j)
                       {
                          case 0 : printf("%c", c+3); 
                                   break;
                          case 1 : printf("%c", c);
                                   break;
                          case 2 : printf("%c", c+2); 
                                   break;
                       }
                    }
                 }
                 break;
      default  : printf("Satz mit X: war wohl nix...\n");
   }
   printf("\n");
}
/*****************************************************************************/
/* Typ 1 = String                                                            */
/*****************************************************************************/
typ1()
{
   if((strncmp(ST[zeile]+6, "Call", 4) == 0))
      strcpy(CALL, akt+delta);
   if(strncmp(ST[zeile]+6, "Name", 4) == 0)
      strcpy(NAME, akt+delta);
   if(strncmp(ST[zeile]+6, "Sprache", 7) == 0)
      strcpy(SPRACHE, akt+delta);
   if(arg == 0)
      printf("<%-6.6s>  ",CALL);
   if(arg <= 1)
      printf("%s%s\n", ST[zeile]+6, akt+delta);
   if(arg == 2)
      if((strncmp(ST[zeile]+6, "Pawort", 7) == 0))
         password();
      else
         printf("%s%s\n", ST[zeile]+6, akt+delta);
}
/*****************************************************************************/
/* Typ 2 = String (Rufzeichen mit SSID)                                      */
/*****************************************************************************/
typ2()
{
   int c, i;

   if(arg == 0)
      printf("<%-6.6s>  ",CALL);
   if(arg <= 2)
      printf("%s%s\n", ST[zeile]+6, akt+delta);
   if(strncmp(ST[zeile]+6, "MyBBS", 5) == 0)
      strcpy(MYBBS, akt+delta);
}
/*****************************************************************************/
/* Typ 3 = Byte                                                              */
/*****************************************************************************/
typ3()
{
   int c;
   c = *(akt+delta) & 0xff;
   if(arg == 0)
      printf("<%-6.6s>  ",CALL);
   if(arg <= 2)
      printf("%s%d\n", ST[zeile]+6, c);
}
/*****************************************************************************/
/* Typ 4 = unsigned short                                                    */
/*****************************************************************************/
typ4()
{
   union xyz
   {
      unsigned short c;
      unsigned char x[2];
   } xy;

   xy.x[0] = akt[delta];
   xy.x[1] = akt[delta+1];
   if(arg == 0)
      printf("<%-6.6s>  ",CALL);
   if(arg <= 2)
      printf("%s%u\n", ST[zeile]+6, xy.c);
   if(strncmp(ST[zeile]+6, "Filepos", 7) == 0)
      FILEPOS = xy.c;
}
/*****************************************************************************/
/* Typ 5 = long                                                              */
/*****************************************************************************/
typ5()
{
   long c;
   c = (long) *(akt+delta);
   c = c + (long) 256*(*(akt+delta+1));
   c = c + (long) 256*256*(*(akt+delta+2));
   c = c + (long) 256*256*256*(*(akt+delta+3));
   if(arg == 0)
      printf("<%-6.6s>  ",CALL);
   if(arg <= 2)
      printf("%s%ld\n", ST[zeile]+6, c);
}
/*****************************************************************************/
/* Typ 6 = time_t                                                            */
/*****************************************************************************/
typ6()
{
   long clock;
   clock = (long) *(akt+delta);
   clock = clock + (long) 256*(*(akt+delta+1));
   clock = clock + (long) 256*256*(*(akt+delta+2));
   clock = clock + (long) 256*256*256*(*(akt+delta+3));
   if(arg == 0)
      printf("<%-6.6s>  ",CALL);
   if(strncmp(ST[zeile]+6, "MYBBStime", 9) == 0)
      sprintf(MYBBST, "%ld", clock);
   if(arg <= 2)
      printf("%s%s", ST[zeile]+6, ctime(&clock));
}
/*****************************************************************************/
/* Typ 7 = String mit Laenge groesser 60 ???                                 */
/*****************************************************************************/
typ7()
{
   if(arg <= 2)
   {
      if(strlen(akt+delta) < 61)
      {
         if(arg == 0)
            printf("<%-6.6s>  ",CALL);
         printf("%s%s\n", ST[zeile]+6, akt+delta);
      }
      else
      {
         if(arg == 0)
            printf("<%-6.6s>  ",CALL);
         printf("%s%-60.60s\n", ST[zeile]+6, akt+delta);
         if(arg == 0)
            printf("<%-6.6s>  ",CALL);
         printf("             A : %s\n", akt+delta+60);
      }
   }
}
/*****************************************************************************/
/* Typ 8 = Bitfeld mit Optionen                                              */
/*****************************************************************************/
typ8()
{
   int j;
   union xyz
   {
      long c;
      unsigned char x[5];
   } xy;

   if(arg <= 2)
   {
      if(arg == 0)
         printf("<%-6.6s>  ",CALL);
      printf("%s", ST[zeile]+6);
      xy.x[0] = akt[delta];
      xy.x[1] = akt[delta+1];
      xy.x[2] = akt[delta+2];
      xy.x[3] = akt[delta+3];
      for(j=0; j<26; j++)
      {
         if((xy.c >> j) & 0x01 != 0)
            printf("%c", 'A'+j);
      }
      printf("\n");      
   }
}
/*****************************************************************************/
/* strrev ()                                                                 */
/*****************************************************************************/
char *strrev(name)
char *name;
{
   char temp[200];
   int i, l;

   l = strlen(name)-1;

   for(i=0; i<strlen(name); i++)
   {
      temp[i] = name[l-i];
   }
   temp[i] = '\0';
   return (temp);
}
/*****************************************************************************/
void strupr(char *z)
{
   int i;
   for(i=0; i<strlen(z); i++)
      z[i] = toupper(z[i]);
}
/*****************************************************************************/
/* Hauptprogramm - Aufruf mit:                                               */
/*                                                                           */
/*    UDAT call                           arg = 2       normale Ausgabe      */
/*    UDAT call (kuerzer als 5 Zeichen)   arg = 1       Ausgabe ==> UDAT.DAT */
/*    UDAT !                              arg = 0       Ausgabe ==> UDAT.DAT */
/*    UDAT ! x                            arg = 3       Ausgabe ==> UDAT.IMP */
/*    UDAT ! l                            arg = 3       Ausgabe ==> UDAT.IMP */
/*                                                                           */
/*****************************************************************************/
void main(argc, argv)
int  argc;
char *argv[];
{
   extern int daylight;
   extern long timezone;
   int    i;

   printf("UDAT  V 4.0  von DJ1XK\n\n");
   if(argc == 1)
   {
      printf("\n Aufruf: UDAT call    Anzeige der Daten zu call");
      printf("\n              wenn call kuerzer als 5 Zeichen: alles gefundene ==> udat.dat");
      printf("\n         UDAT !       alle Daten ==> udat.dat");
      printf("\n         UDAT ! X     Erzeugen einer udat.imp");
      printf("\n         UDAT ! L     Erzeugen einer udat.imp, aber mit SETU -L\n");
      exit(0);
   }
   
   arg = argc;
   l = strlen(argv[1]);
   if(arg == 3)
      fi = fopen ("udat.imp", "w");
   if(arg == 2 && l < 5)
      arg = 1;
   if(argc == 2 && argv[1][0] == '!')
      arg = 0;
   if(arg != 2)
      printf(" ... bitte warten - es dauert etwas ...\n\n");
   if(arg <= 1)
      pt = freopen("udat.dat", "w", stdout);

   def();                              /* DEF-Daten einlesen */
   daylight = 0;
   timezone = 0;

   if((fd = open (datnam, O_RDONLY)) == -1)
   {
      fprintf(stderr, "\n Datei USERS4.BCM nicht gefunden - Abbruch !\n");
      exit(1);
   }

   while(read(fd, akt, 640) != 0)
   {
      strupr(argv[1]);
      f= strncmp(akt, argv[1], l);
      if(f == 0 || arg == 0 || arg == 3 || arg == 4)
      { 
         delta = 0;
         typ = 0;
         if(arg < 2)
            printf("\n\n");
         for(zeile=0; typ<999; zeile++)
         {  typ = atoi(ST[zeile]);
            ll = atoi(ST[zeile]+2);
            if(f == 0 || arg != 1)
            {          
               switch (typ)
               {
                  case 0 : break;
                  case 1 : typ1();
                           break;
                  case 2 : typ2();
                           break;
                  case 3 : typ3();
                           break;
                  case 4 : typ4();
                           break;
                  case 5 : typ5();
                           break;
                  case 6 : typ6();
                           break;
                  case 7 : typ7();
                           break;
                  case 8 : typ8();
                           break;
                  default: typ = 999;
               }
            }
            delta = delta + ll;
         }
         if(arg == 2)
            break;
         if(arg == 3 && (strncmp(akt, "DUMMY", 5) != 0))
         {
            fprintf(fi, "SETU %s D\n", CALL);
            fprintf(fi, "j\n");
            if(strlen(NAME) != 0)
               fprintf(fi, "SETU %s N %s\n", CALL, NAME);
            if(strlen(MYBBS) != 0)
            {
               if(strcmp(argv[2], "X") == 0)
                  fprintf(fi, "SETU %s F %s %s\n", CALL, MYBBS, MYBBST);
               else
                  fprintf(fi, "SETU %s F -L %s %s\n", CALL, MYBBS, MYBBST);
            }
            fprintf(fi, "SETU %s SP %s\n", CALL, SPRACHE);
         }
      }
   }
   if(arg == 3)
      fprintf(stderr, "\n maximale Satzzahl ist %u !", FILEPOS);
   fprintf(stderr, "\n ... fertig ...\n\n");
}
/*****************************************************************************/
